// EcoModeler - C# Edition :: Version 9.17 build 3378
using System;
using System.ComponentModel;
using System.Collections;
using System.Collections.Generic;
using Eco.Services;
using Eco.ObjectRepresentation;
using Eco.ObjectImplementation;
using Eco.UmlRt;
using Eco.UmlCodeAttributes;
using Eco.Subscription;

namespace DevGroupGettingStartedWithEco.Model
{
	#region MM_ECO_Generated
	#region Attributes
	[UmlElement(Id="{09ed3748-562a-4ed5-99c0-6301dabe6cb6}")]
	#endregion

	#endregion
	public class InvoiceItem: object, ILoopBack
	{
		#region MM_ECO AutoGenerated ECO code

		protected IContent eco_Content;

		IObject IObjectProvider.AsIObject()
		{
			return this.eco_Content.AsIObject();
		}

		public IObjectInstance AsIObject()
		{
			return this.eco_Content.AsIObject();
		}

		public struct Eco_LoopbackIndices
		{
			public const int Eco_FirstMember = 0;
			public const int Eco_MemberCount = (Eco_FirstMember + 4);
			public const int Invoice_MemberIndex = Eco_FirstMember + 0;
			public const int ItemTotal_MemberIndex = Eco_FirstMember + 1;
			public const int Product_MemberIndex = Eco_FirstMember + 2;
			public const int Quantity_MemberIndex = Eco_FirstMember + 3;
		}

		public virtual object get_MemberByIndex(int index)
		{
			switch (index)
			{
				case Eco_LoopbackIndices.ItemTotal_MemberIndex: return this.ItemTotal;
				default: throw new System.IndexOutOfRangeException();
			}
		}

		public virtual void set_MemberByIndex(int index, object value)
		{
			switch (index)
			{
				default: throw new System.IndexOutOfRangeException();
			}
		}

		protected void Initialize(IEcoServiceProvider serviceProvider)
		{
			if ((this.eco_Content == null))
			{
				IInternalObjectContentFactory factory = ((IInternalObjectContentFactory)(serviceProvider.GetEcoService(typeof(IInternalObjectContentFactory))));
				this.eco_Content = factory.CreateContent(this);
				this.eco_Content.LoopbackValid();
			}
		}

		protected void Deinitialize(IEcoServiceProvider serviceProvider)
		{
			if ((this.eco_Content != null))
			{
				IInternalObjectContentFactory factory = ((IInternalObjectContentFactory)(serviceProvider.GetEcoService(typeof(IInternalObjectContentFactory))));
				factory.CreateContentFailed(this.eco_Content, this);
				this.eco_Content = null;
			}
		}
		#endregion

		#region MM_ECO Model owned attributes
		//Note: Do not remove any property within this region, nor change its signature

		#region MM_ECO_Generated
		[UmlElement("AssociationEnd", Index=(InvoiceItem.Eco_LoopbackIndices.Invoice_MemberIndex), Id="{ebe8ebad-a67f-42b4-81b5-e4983e04d7cd}")]
		[UmlMetaAttribute("association", typeof(GettingStartedWithEcoPackage.InvoiceInvoiceItems), Index=1)]
		[UmlMetaAttribute("multiplicity", "1")]
		[UmlTaggedValue("Eco.Embed", "True")]
		#endregion
		public DevGroupGettingStartedWithEco.Model.Invoice Invoice
		{
			get
			{
				#region MM_ECO_Generated
				return (DevGroupGettingStartedWithEco.Model.Invoice) (this.eco_Content.get_MemberByIndex(Eco_LoopbackIndices.Invoice_MemberIndex));
				#endregion
			}
			set
			{
				#region MM_ECO_Generated
				this.eco_Content.set_MemberByIndex(Eco_LoopbackIndices.Invoice_MemberIndex, ((object)(value)));
				#endregion
			}
		}

		#region MM_ECO_Generated
		[UmlElement("AssociationEnd", Index=(InvoiceItem.Eco_LoopbackIndices.Product_MemberIndex), Id="{b2c12380-597c-4d65-afdb-3cfec948b277}")]
		[UmlMetaAttribute("association", typeof(GettingStartedWithEcoPackage.ProductInvoiceItems), Index=1)]
		[UmlMetaAttribute("multiplicity", "0..1")]
		[UmlTaggedValue("Eco.Embed", "True")]
		#endregion
		public DevGroupGettingStartedWithEco.Model.Product Product
		{
			get
			{
				#region MM_ECO_Generated
				return (DevGroupGettingStartedWithEco.Model.Product) (this.eco_Content.get_MemberByIndex(Eco_LoopbackIndices.Product_MemberIndex));
				#endregion
			}
			set
			{
				#region MM_ECO_Generated
				this.eco_Content.set_MemberByIndex(Eco_LoopbackIndices.Product_MemberIndex, ((object)(value)));
				#endregion
			}
		}

		#region MM_ECO_Generated
		#region Attributes
		[UmlElement(Index=(InvoiceItem.Eco_LoopbackIndices.Quantity_MemberIndex), Id="{80494a1c-c9ed-48d9-812a-af579f5aab5f}")]
		[UmlMetaAttribute("initialValue", "1")]
		[UmlTaggedValue("Eco.Length", "255")]
		#endregion

		#endregion
		public int Quantity
		{
			get
			{
				#region MM_ECO_Generated
				return (int) (this.eco_Content.get_MemberByIndex(Eco_LoopbackIndices.Quantity_MemberIndex));
				#endregion
			}
			set
			{
				#region MM_ECO_Generated
				this.eco_Content.set_MemberByIndex(Eco_LoopbackIndices.Quantity_MemberIndex, ((object)(value)));
				#endregion
			}
		}

		#region MM_ECO_Generated
		#region Attributes
		[UmlElement(Index=(InvoiceItem.Eco_LoopbackIndices.ItemTotal_MemberIndex), Id="{4abd1a13-d9cf-4784-99e0-1c846fd85656}")]
		[UmlTaggedValue("persistence", "transient")]
		[UmlTaggedValue("derived", "True")]
		[UmlTaggedValue("Eco.Length", "255")]
		[UmlTaggedValue("Eco.HasUserCode", "True")]
		#endregion

		#endregion
		public decimal ItemTotal
		{
			get
			{
				#region MM_ECO_Generated
				return (decimal) (this.eco_Content.get_MemberByIndex(Eco_LoopbackIndices.ItemTotal_MemberIndex));
				#endregion
			}
		}
		#endregion

		#region MM_ECO Model owned methods
		//Note: Do not remove any method within this region, nor change its signature

		public InvoiceItem(IContent content)
		{
			#region MM_ECO_Generated
			this.eco_Content = content;
			content.AssertLoopbackUnassigned();
			#endregion
		}

		public InvoiceItem(IEcoServiceProvider serviceProvider)
		{
			this.Initialize(serviceProvider);
			try
			{
				// Place user code ONLY here
			}
			catch (System.Exception)
			{
				this.Deinitialize(serviceProvider);
				throw;
			}
		}

		#region MM_ECO_Generated
		#region Attributes
		[UmlElement(Id="{697146ed-9058-455b-90b5-cbbc78c595bc}")]
		#endregion

		#endregion
		public decimal ItemTotalDerive()
		{
            // TODO
            if (this.Product != null)
            {
                return Product.Price * Quantity;
            }
            else
                return decimal.Zero;
		}
		#endregion
	}
}
