using System;
using System.Drawing;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Eco.Handles;
using Eco.Windows.Forms;
using Eco.WinForm;
using Eco.ObjectRepresentation;
using Eco.Services;

using DevGroupGettingStartedWithEco.Model;


namespace DevGroupGettingStartedWithEco
{
    /// <summary>
    /// Summary description for ManageProducts.
    /// </summary>
    public partial class ManageProducts : System.Windows.Forms.Form
    {

        public ManageProducts(DevGroupGettingStartedWithEco.DevGroupGettingStartedWithEcoEcoSpace ecoSpace)
        {
            //
            // Required for Windows Form Designer support
            //
            InitializeComponent();

            // Set EcoSpace (actually stores it in rhRoot.EcoSpace)
            // Note that you need to set the EcoSpace property for 
            // each ReferenceHandle and VariableHandle you add to 
            // the form.
            rhRoot.EcoSpace = ecoSpace;
        }

        public DevGroupGettingStartedWithEco.DevGroupGettingStartedWithEcoEcoSpace EcoSpace
        {
            get { return (DevGroupGettingStartedWithEco.DevGroupGettingStartedWithEcoEcoSpace)rhRoot.EcoSpace; }
        }

        private void btnAddProduct_Click(object sender, EventArgs e)
        {
            // This is a code example of how to create a new Eco Object
            Product addition = new Product(this.EcoSpace);
            addition.Name = "Please change this name";
        }

        private void btnDeleteProduct_Click(object sender, EventArgs e)
        {
            // Get the currently selected Product in the Grid, and then confirm with the user that
            // they actually want this item deleted.
            if (cmhCurrentProduct.Element != null)
            {
                Product selected = cmhCurrentProduct.Element.AsObject as Product;
                if (selected != null)
                {
                    DialogResult dr = MessageBox.Show(string.Format("Delete this Product: {0}", selected.Name), "Confirm Product Deletion", MessageBoxButtons.YesNo);
                    if (dr == DialogResult.Yes)
                    {
                        selected.AsIObject().Delete();

                        this.EcoSpace.UpdateDatabase();
                    }
                }
            }
        }

        private void ManageProducts_FormClosing(object sender, FormClosingEventArgs e)
        {
            if (this.EcoSpace.DirtyList.HasDirtyObjects())
            {
                this.EcoSpace.UpdateDatabase();
            }
        }
    }
}
